using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Driver;
using MudBlazor;

namespace Insight.Web.Pages.Management.Hosts.Systems.StoragePools;

[Route(Navigation.Management.Hosts.Systems.StoragePools.Details)]
public partial class Details
{
    [Parameter] public string? HostId { get; set; }
    [Parameter] public string? StoragePoolId { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private NavigationManager NavigationManager { get; init; } = default!;

    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private HostStoragePoolEntity? HostStoragePool { get; set; }

    private async Task LoadDataAsync()
    {
        Breadcrumbs.Clear();
        HostStoragePool = null;

        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Hosts", href: Navigation.Management.Hosts.Index));

        StateHasChanged();

        if (string.IsNullOrWhiteSpace(HostId) || ObjectId.TryParse(HostId, out var hostId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        var host = await Database.Host()
            .Find(Builders<HostEntity>
            .Filter
            .Eq(p => p.Id, HostId))
            .FirstOrDefaultAsync(default);

        if (host is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        Breadcrumbs.Add(new BreadcrumbItem(host.Name, href: Navigation.Management.Hosts.DetailsHref(HostId)));
        Breadcrumbs.Add(new BreadcrumbItem("Storage Pools", href: Navigation.Management.Hosts.Systems.StoragePools.IndexHref(HostId)));

        StateHasChanged();

        if (string.IsNullOrWhiteSpace(StoragePoolId) || ObjectId.TryParse(StoragePoolId, out var storagePoolId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Systems.StoragePools.IndexHref(HostId));
            return;
        }

        HostStoragePool = await Database.HostStoragePool()
            .Aggregate()
            .Match(p => p.Host == HostId && p.Id == StoragePoolId)
            .Lookup<HostStoragePoolEntity, HostStoragePoolPhysicalDiskEntity, HostStoragePoolEntity>(Database.HostStoragePoolPhysicalDisk(), p => p.Id, p => p.StoragePool, p => p.PhysicalDisks)
            .Lookup<HostStoragePoolEntity, HostStoragePoolVirtualDiskEntity, HostStoragePoolEntity>(Database.HostStoragePoolVirtualDisk(), p => p.Id, p => p.StoragePool, p => p.VirtualDisks)
            .FirstOrDefaultAsync();

        if (HostStoragePool is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Systems.StoragePools.IndexHref(HostId));
            return;
        }

        Title = $"Hosts » {host.Name} » Storage Pools » {HostStoragePool.Name}｜Insight";

        Breadcrumbs.Add(new BreadcrumbItem(HostStoragePool.Name, href: "#", true));

        StateHasChanged();
    }
}